Index: tmp/org.txm.core/src/java/org/txm/core/results/TXMResult.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/core/results/TXMResult.java	(revision 1428)
+++ tmp/org.txm.core/src/java/org/txm/core/results/TXMResult.java	(revision 1429)
@@ -10,7 +10,6 @@
 import java.util.Date;
 import java.util.HashMap;
 import java.util.List;
-import java.util.TreeSet;
 import java.util.concurrent.Semaphore;
 import java.util.regex.Pattern;
 
@@ -39,20 +38,15 @@
  * 
  * A TXMResult always have a parent (except the root: @see Workspace).
  * 
- * To compute a result simply call the {@link #compute()} method. It contains
- * all the life cycle steps of the result.
+ * To compute a result simply call the {@link #compute()} method. It contains all the life cycle steps of the result.
  * 
- * To set parameters, you can alternatively call the {@link #setParameters()}
- * methods or the setXXX methods. The setParameters methods are usually useful
- * to transfer several parameters at once.
+ * To set parameters, you can alternatively call the {@link #setParameters()} methods or the setXXX methods. The setParameters methods are usually useful to transfer several parameters at once.
  * 
- * The class contains convenient methods to maintain the same logic between
- * results : - canCompute() : test if all necessary parameters are set -
- * isDirty(): return true if the result needs to be recomputed (if a parameter
- * changed)
+ * The class contains convenient methods to maintain the same logic between results :
+ * - canCompute() : test if all necessary parameters are set
+ * - isDirty(): return true if the result needs to be recomputed (if a parameter changed)
  * 
  * Groovy call sample :
- * 
  * <pre>
  * {@code
  * MyTXMResult result = new MyTXMResult(parent);
@@ -65,7 +59,6 @@
  * </pre>
  * 
  * @author mdecorde
- * 
  * @author sjacquot
  */
 public abstract class TXMResult implements Cloneable, IProgressMonitor, Comparable<TXMResult> {
@@ -76,12 +69,13 @@
 	public static final String UNDERSCORE = "_";
 
 	private static int next = 0;
-	//TreeSet<TXMResultListener> listeners = new TreeSet<>();
+	
 
-	// /**
-	// * Unique ID of the result.
-	// */
-	// protected String uniqueID;
+	
+//	/**
+//	 * Unique ID of the result.
+//	 */
+//	protected String uniqueID;
 
 	/**
 	 * Editor can use this to test if the result has been computed once.
@@ -94,19 +88,18 @@
 	protected int weight;
 
 	/**
-	 * the command this command to true when the result needs to be recomputed. like
-	 * after updating parameters
+	 * the command this command to true when the result needs to be recomputed.
+	 * like after updating parameters
 	 */
 	protected boolean dirty = true;
-
+	
 	/**
 	 * if frozen, the result is not updated when computed
 	 */
 	protected boolean frozen = false;
-
+	
 	/**
-	 * if a method changed the internal data without **recomputing** the result, the
-	 * result must be marked "altered"
+	 * if a method changed the internal data without **recomputing** the result, the result must be marked "altered"
 	 */
 	protected boolean altered = false;
 
@@ -124,12 +117,10 @@
 	 * Command preferences node path.
 	 */
 	protected String commandPreferencesNodePath;
-	// protected IEclipsePreferences preferencesNode; // TODO: directly use a
-	// preferences node rather than a node path?
+	//protected IEclipsePreferences preferencesNode; // TODO: directly use a preferences node rather than a node path?
 
 	/**
-	 * Parameters node path. Concatenation of the Project scope path + the result
-	 * uuid
+	 * Parameters node path. Concatenation of the Project scope path + the result uuid
 	 */
 	protected String parametersNodePath;
 
@@ -144,18 +135,14 @@
 	private Semaphore progressSemaphore = new Semaphore(1);
 
 	/**
-	 * To keep track of the parameters used for the last computing and to determine
-	 * if the result is dirty.
+	 * To keep track of the parameters used for the last computing and to determine if the result is dirty. 
 	 */
-	// FIXME: SJ: actually only used by the chart results. Purpose here is that the
-	// chart creators need to know if a computing parameter has changed to recreate
-	// or not some entity.
-	// The problem is since the result is already computing, the parameters are
-	// already updated and the method hasParameterChanged() will always return
-	// false. Using this stack fix the problem.
+	// FIXME: SJ: actually only used by the chart results. Purpose here is that the chart creators need to know if a computing parameter has changed to recreate or not some entity.
+	// The problem is since the result is already computing, the parameters are already updated and the method hasParameterChanged() will always return false. Using this stack fix the problem.
 	// But this stack is also the start for an UNDO command on TXMResult.
 	protected ArrayList<HashMap<String, Object>> parametersHistory = new ArrayList<HashMap<String, Object>>();
 
+	
 	/**
 	 * Internal persistable state.
 	 */
@@ -169,26 +156,28 @@
 	/**
 	 * The visibility state.
 	 */
-	@Parameter(key = TXMPreferences.VISIBLE, type = Parameter.INTERNAL)
+	@Parameter(key=TXMPreferences.VISIBLE, type=Parameter.INTERNAL)
 	private Boolean visible;
 
 	/**
 	 * The user name (to rename a result).
 	 */
-	@Parameter(key = TXMPreferences.USER_NAME, type = Parameter.INTERNAL)
+	@Parameter(key=TXMPreferences.USER_NAME, type=Parameter.INTERNAL)
 	protected String userName;
 
 	/**
-	 * To store the simple name for unserialization and lazy loading. This string
-	 * can be used, for example, to display some infos in UI even if the result has
-	 * not yet been recomputed.
+	 *  To store the simple name for unserialization and lazy loading.
+	 *  This string can be used, for example, to display some infos in UI even if the result has not yet been recomputed.
 	 */
-	@Parameter(key = TXMPreferences.LAZY_NAME, type = Parameter.INTERNAL)
+	@Parameter(key=TXMPreferences.LAZY_NAME, type=Parameter.INTERNAL)
 	private String lazyName;
 
+
+
+
+
 	/**
 	 * Creates a new TXMResult, child of the specified parent.
-	 * 
 	 * @param parent
 	 */
 	public TXMResult(TXMResult parent) {
@@ -196,10 +185,8 @@
 	}
 
 	/**
-	 * Creates a new TXMResult with no parent. If a local node exist with the
-	 * parent_uuid, the parent will be retrieved and this result will be added to
-	 * it.
-	 * 
+	 * Creates a new TXMResult with no parent.
+	 * If a local node exist with the parent_uuid, the parent will be retrieved and this result will be added to it. 
 	 * @param uuid
 	 */
 	public TXMResult(String parametersNodePath) {
@@ -207,9 +194,8 @@
 	}
 
 	/**
-	 * Creates a new TXMResult, child of the specified parent. If the parameters
-	 * node path is null, a new path is generated from the project root path ending
-	 * by a new generated UUID.
+	 * Creates a new TXMResult, child of the specified parent.
+	 * If the parameters node path is null, a new path is generated from the project root path ending by a new generated UUID.
 	 * 
 	 * @param uuid
 	 * @param parent
@@ -222,14 +208,15 @@
 			parent.addChild(this);
 		}
 
-		if (parametersNodePath == null) {
-			if (this.getProject() != null) {
+		if (parametersNodePath == null)	{
+			if (this.getProject() != null)	{
 				parametersNodePath = this.getProject().getParametersNodeRootPath();
 			} else {
 				parametersNodePath = "";
 			}
-			this.parametersNodePath = parametersNodePath + createUUID() + "_" + this.getClass().getSimpleName(); //$NON-NLS-1$ ;
-		} else {
+			this.parametersNodePath = parametersNodePath + createUUID() + "_" + this.getClass().getSimpleName(); //$NON-NLS-1$;
+		}
+		else	{
 			this.parametersNodePath = parametersNodePath;
 		}
 
@@ -238,56 +225,60 @@
 		this.weight = 0;
 
 		this.children = new ArrayList<TXMResult>(1);
-		// this.children = Collections.synchronizedList(new ArrayList<TXMResult>()); //
-		// FIXME: SJ: can fix the conccurent excpetion if needed
+		//this.children = Collections.synchronizedList(new ArrayList<TXMResult>()); // FIXME: SJ: can fix the conccurent excpetion if needed
 
-		this.commandPreferencesNodePath = FrameworkUtil.getBundle(getClass()).getSymbolicName(); // $NON-NLS-1$
+		this.commandPreferencesNodePath = FrameworkUtil.getBundle(getClass()).getSymbolicName(); //$NON-NLS-1$
 		Log.finest("TXMResult.TXMResult(): command preferences node path: " + this.commandPreferencesNodePath + "."); //$NON-NLS-1$ //$NON-NLS-2$
 
+
 		this.visible = true;
 		this.dirty = true;
 		this.internalPersistable = false;
 		this.userPersistable = TBXPreferences.getInstance().getBoolean(TBXPreferences.AUTO_PERSISTENCE_ENABLED);
 
+
 		// retrieving parent from UUID
 		String parentNodePath = this.getStringParameterValue(TXMPreferences.PARENT_PARAMETERS_NODE_PATH);
 
-		// System.out.println("TXMResult.TXMResult(): parent UUID = " + parentUUID);
+		//System.out.println("TXMResult.TXMResult(): parent UUID = " + parentUUID);
 
 		if (!("ROOT".equals(this.parametersNodePath)) && // search for parent only if UUID != "ROOT"
-				parent == null && this.parametersNodePath != null && !parentNodePath.isEmpty()) {
+				parent == null && 
+				this.parametersNodePath != null && 
+				!parentNodePath.isEmpty()) {
 			Log.finest("Searching parent with UUID: " + parentNodePath + "..."); //$NON-NLS-1$ //$NON-NLS-2$
 			TXMResult retrievedParent = TXMResult.getResult(parentNodePath);
 			if (retrievedParent != null) {
 				Log.finest("Parent retrieved from UUID: " + retrievedParent + "."); //$NON-NLS-1$ //$NON-NLS-2$
 				retrievedParent.addChild(this);
-			} else {
+			}
+			else {
 				Log.severe("Warning: no parent was found in project for path=" + parametersNodePath + " and puuid=" + parentNodePath + " preferences=" + this.dumpParameters()); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
 				// FIXME: commented for now
-				// TBXPreferences.delete(this);
+				//TBXPreferences.delete(this);
 				return;
 			}
 		}
 
-		// loads parameters from local result node, current command preferences or
-		// default command preferences
+		// loads parameters from local result node, current command preferences or default command preferences
 		try {
 			this.autoLoadParametersFromAnnotations(); // auto fill from Parameter annotations
-			this.loadParameters(); // subclasses manual settings
+			this.loadParameters();  // subclasses manual settings
 		} catch (Exception e) {
 			Log.severe("Fail to load " + parametersNodePath + "result: " + e); //$NON-NLS-1$ //$NON-NLS-2$
 			Log.printStackTrace(e);
 		}
 
 		// Log
-		if (this.parent == null) {
+		if (this.parent == null)	{
 			Log.finest("Warning: the TXMResult of " + this.getClass() + " is attached to no parent. (uuid = " + this.parametersNodePath + ")");//$NON-NLS-1$ //$NON-NLS-2$
 		}
 
 		try {
 			this.parametersHistory.add(new HashMap<String, Object>());
-			// this.updateLastParameters();
-		} catch (Exception e) {
+			//this.updateLastParameters();
+		}
+		catch (Exception e) {
 			// TODO Auto-generated catch block
 			e.printStackTrace();
 		}
@@ -295,7 +286,6 @@
 
 	/**
 	 * Sets the user name.
-	 * 
 	 * @param name
 	 */
 	public void setUserName(String name) {
@@ -308,26 +298,21 @@
 	public boolean isAltered() {
 		return altered;
 	}
-
+	
 	/**
 	 * Mark the result as altered -> modifications are lost after a re-compute
-	 * 
-	 * children are marked dirty since data has been modified
 	 */
 	public void setAltered() {
 		this.altered = true;
-		for (TXMResult r : getChildren()) {
-			r.setDirty();
-		}
 	}
-
+	
 	/**
 	 * Freezes the result -> cannot be recomputed.
 	 */
 	public void freeze() {
 		this.frozen = true;
 	}
-
+	
 	/**
 	 * Unfreezes the result -> can be recomputed.
 	 */
@@ -341,27 +326,24 @@
 	public void setFrozen(boolean frozen) {
 		this.frozen = frozen;
 	}
-
+	
 	/**
 	 * @return true if the resutl is frozen
 	 */
 	public boolean isFrozen() {
 		return this.frozen;
 	}
-
+	
 	/**
 	 * Creates an UUID dedicated to persistence of this result.
-	 * 
 	 * @return
 	 */
 	public static String createUUID() {
-		// FIXME: see if it's useful to put the class name or not, should be better to
-		// save it in the .prefs
-		// this.uniqueID = this.getClass().getName() + '@' + ID_TIME_FORMAT.format(new
-		// Date(System.currentTimeMillis())) + "_" + UUID.randomUUID();
+		// FIXME: see if it's useful to put the class name or not, should be better to save it in the .prefs
+		//this.uniqueID = this.getClass().getName() + '@' + ID_TIME_FORMAT.format(new Date(System.currentTimeMillis())) + "_" + UUID.randomUUID();
 		return UUID_PREFIX + ID_TIME_FORMAT.format(new Date(System.currentTimeMillis())) + "_" + nextInt();
 	}
-
+	
 	/**
 	 * 
 	 * @return the next integer in the current session of TXM
@@ -372,13 +354,13 @@
 
 	/**
 	 * Checks if the result at least one child.
-	 * 
 	 * @return
 	 */
 	public boolean hasChildren() {
 		return this.children.size() > 0;
 	}
 
+
 	/**
 	 * Gets the preferences node path of the result command.
 	 * 
@@ -388,6 +370,7 @@
 		return this.commandPreferencesNodePath;
 	}
 
+
 	public String[] getCommandPreferencesKeys() throws BackingStoreException {
 		return TXMPreferences.getCommandScopeKeys(this.commandPreferencesNodePath);
 	}
@@ -397,9 +380,7 @@
 	}
 
 	/**
-	 * Gets a current parameter specified by its annotation "key" attribute and its
-	 * annotation "type" attribute.
-	 * 
+	 * Gets a current parameter specified by its annotation "key" attribute and its annotation "type" attribute.
 	 * @param key
 	 * @param parameterType
 	 * @return
@@ -409,21 +390,18 @@
 	}
 
 	/**
-	 * Gets a current parameter specified by its annotation "key" attribute and its
-	 * annotation "type" attribute.
-	 * 
+	 * Gets a current parameter specified by its annotation "key" attribute and its annotation "type" attribute.
 	 * @param key
-	 * @param propagateToParent
-	 *            if true ask the parents
+	 * @param propagateToParent if true ask the parents
 	 * @param parameterType
 	 * @return
 	 */
 	public Object getParameter(String key, boolean propagateToParent) {
 		try {
-			Field field = this.getField(key);
-			if (field != null) {
+			Field field = this.getField(key); 
+			if (field != null)	{
 				field.setAccessible(true);
-				return field.get(this);
+				return field.get(this);	
 			} else if (propagateToParent && this.parent != null) {
 				return this.parent.getParameter(key, propagateToParent);
 			}
@@ -433,15 +411,15 @@
 		return null;
 	}
 
+
 	/**
 	 * Gets a member field according to its key.
-	 * 
 	 * @param key
 	 * @return the field if exists otherwise null
 	 */
-	public Field getField(String key) {
+	public Field getField(String key)	{
 
-		Field field = null;
+		Field field = null; 
 
 		List<Field> fields = this.getAllFields();
 
@@ -458,10 +436,9 @@
 
 	/**
 	 * Returns all the member fields of the class instance.
-	 * 
 	 * @return the list of declared fields
 	 */
-	public List<Field> getAllFields() {
+	public List<Field> getAllFields()	{
 
 		List<Field> fields = new ArrayList<Field>();
 		Class<?> clazz = this.getClass();
@@ -476,16 +453,15 @@
 
 	/**
 	 * Stores the parameters of the specified type used for last computing.
-	 * 
 	 * @throws Exception
 	 */
 	protected void updateLastParameters(int parameterType) throws Exception {
 		this.updateLastParameters(parameterType, false);
 	}
 
+
 	/**
 	 * Stores the parameters of the specified type used for last computing.
-	 * 
 	 * @param parameterType
 	 * @param appendToLastParameters
 	 * @throws Exception
@@ -494,9 +470,10 @@
 
 		HashMap<String, Object> lastParameters;
 
-		if (appendToLastParameters) {
+		if(appendToLastParameters)	{
 			lastParameters = this.getLastParametersFromHistory();
-		} else {
+		}
+		else	{
 			lastParameters = new HashMap<>();
 		}
 
@@ -509,9 +486,10 @@
 			}
 
 			String name;
-			if (!parameter.key().isEmpty()) {
+			if(!parameter.key().isEmpty())	{
 				name = parameter.key();
-			} else {
+			}
+			else	{
 				name = f.getName();
 			}
 
@@ -519,13 +497,13 @@
 			lastParameters.put(name, f.get(this));
 		}
 
-		if (!appendToLastParameters) {
+		if(!appendToLastParameters)	{
 			this.parametersHistory.add(lastParameters);
 		}
 
 		// truncate the stack to the max count
 		// FIXME: store this in a TBX preference
-		if (this.parametersHistory.size() > 5) {
+		if(this.parametersHistory.size() > 5)	{
 			this.parametersHistory.remove(0);
 			this.parametersHistory.remove(0);
 			this.parametersHistory.remove(0);
@@ -535,13 +513,13 @@
 
 	/**
 	 * Stores the last parameters used for computing.
-	 * 
 	 * @throws Exception
 	 */
 	protected void updateLastParameters() throws Exception {
 		this.updateLastParameters(Parameter.COMPUTING);
 	}
 
+
 	/**
 	 * 
 	 * @param parameterType
@@ -557,9 +535,10 @@
 			}
 
 			String name;
-			if (!parameter.key().isEmpty()) {
+			if(!parameter.key().isEmpty())	{
 				name = parameter.key();
-			} else {
+			}
+			else	{
 				name = f.getName();
 			}
 
@@ -567,42 +546,41 @@
 			this.getLastParametersFromHistory().remove(name);
 		}
 
-		if (this.getLastParametersFromHistory().isEmpty()) {
+		if(this.getLastParametersFromHistory().isEmpty())	{
 			this.parametersHistory.remove(this.parametersHistory.size() - 1);
 		}
 	}
 
+
 	/**
-	 * Clears the parameters used for last computing. Dedicated to force a full
-	 * recomputing.
-	 * 
+	 * Clears the parameters used for last computing.
+	 * Dedicated to force a full recomputing.
 	 * @throws Exception
 	 */
 	protected void clearLastComputingParameters() {
 		this.clearLastParameters(Parameter.COMPUTING);
 	}
 
+
 	/**
-	 * Checks if a parameter value has changed since the n-2 computing. This method
-	 * permits to know, for example, if a parent that has already been computed was
-	 * dirty before its computing, then a child can adjust or not its computing,
-	 * regarding to the parent state.
-	 * 
+	 * Checks if a parameter value has changed since the n-2 computing.
+	 * This method permits to know, for example, if a parent that has already been computed was dirty before its computing,
+	 * then a child can adjust or not its computing, regarding to the parent state.
 	 * @param key
 	 * @param older
 	 * @return
 	 */
 	public boolean hasParameterChanged(String key, boolean older) {
-		if (older) {
-			return this.hasParameterChanged(key, this.parametersHistory.get(this.parametersHistory.size() - 2));
-		} else {
+		if(older)	{
+			return this.hasParameterChanged(key, this.parametersHistory.get(this.parametersHistory.size() - 2));	
+		}
+		else	{
 			return this.hasParameterChanged(key);
 		}
 	}
 
 	/**
 	 * Checks if a parameter value has changed since last computing.
-	 * 
 	 * @param key
 	 * @param parameterType
 	 * @return
@@ -612,9 +590,7 @@
 	}
 
 	/**
-	 * Checks if a parameter value has changed since last computing according to the
-	 * specified external map.
-	 * 
+	 * Checks if a parameter value has changed since last computing according to the specified external map.
 	 * @param key
 	 * @param lastParameters
 	 * @return
@@ -623,34 +599,36 @@
 		if (key.isEmpty()) {
 			return false;
 		}
-		// if (this.isDirty()) {
-		// return true;
-		// }
+		//		if (this.isDirty()) {
+		//			return true;
+		//		}
 
 		Object lastValue = lastParameters.get(key);
 		Object newValue = this.getParameter(key);
 		if (lastValue == null) {
-			if (newValue != null) {
+			if(newValue != null)	{
 				return true;
-			} else {
+			}
+			else	{
 				return false;
 			}
-		} else {
+		}
+		else {
 			return !lastValue.equals(newValue);
 		}
 	}
 
+
+
 	/**
-	 * Dumps the command and default preferences of the result preferences node
-	 * qualifier.
-	 * 
+	 * Dumps the command and default preferences of the result preferences node qualifier.
 	 * @return
 	 */
-	public String dumpPreferences() {
+	public String dumpPreferences()	{
 
 		StringBuilder str = new StringBuilder();
 
-		if (TXMPreferences.resultScopeNodeExists(this)) {
+		if(TXMPreferences.resultScopeNodeExists(this))	{
 			str.append("\nResult local node preferences\n"); //$NON-NLS-1$
 			str.append(TXMPreferences.getKeysAndValues(this.getParametersNodePath()));
 		}
@@ -664,22 +642,22 @@
 		return str.toString();
 	}
 
+
 	/**
 	 * Dumps the result computing parameters (Parameter annotation).
-	 * 
 	 * @return
 	 */
-	public String dumpParameters() {
+	public String dumpParameters()	{
 		return this.dumpParameters(Parameter.COMPUTING);
 	}
 
+
 	/**
 	 * Dumps the result computing parameters (Parameter annotation).
-	 * 
 	 * @param parametersType
 	 * @return
 	 */
-	public String dumpParameters(int parametersType) {
+	public String dumpParameters(int parametersType)	{
 
 		StringBuilder str = new StringBuilder();
 
@@ -695,23 +673,26 @@
 			f.setAccessible(true);
 
 			String name;
-			if (!parameter.key().isEmpty()) {
+			if(!parameter.key().isEmpty())	{
 				name = parameter.key();
-			} else {
+			}
+			else	{
 				name = f.getName();
 			}
 
 			try {
 				Object v = f.get(this);
 				if (v != null) {
-					str.append(name + " (" + v.getClass().getSimpleName() + ") = " + v + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
+					str.append(name + " ("+ v.getClass().getSimpleName() + ") = " + v + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
 				} else {
 					str.append(name + " = NULL \n"); //$NON-NLS-1$ //$NON-NLS-2$
 				}
-			} catch (IllegalArgumentException e) {
+			}
+			catch (IllegalArgumentException e) {
 				// TODO Auto-generated catch block
 				e.printStackTrace();
-			} catch (IllegalAccessException e) {
+			}
+			catch (IllegalAccessException e) {
 				// TODO Auto-generated catch block
 				e.printStackTrace();
 			}
@@ -719,58 +700,57 @@
 		return str.toString();
 	}
 
+
+
 	/**
 	 * Updates the dirty state by comparing an old parameter with a new one.
 	 * 
-	 * @param lastValue
-	 *            may be null
-	 * @param newValue
-	 *            may be null
+	 * @param lastValue may be null
+	 * @param newValue may be null
 	 */
 	protected void updateDirty(Object lastValue, Object newValue) {
-		if (lastValue == null && newValue == null) {
+		if(lastValue == null && newValue == null)	{
 			return;
 		}
 		if (lastValue == null || !lastValue.equals(newValue)) {
-			Log.info("TXMResult.updateDirty(): " + this.getClass().getSimpleName() + ": setting dirty to true: last = " + lastValue + " / new = " + newValue);
+			Log.info("TXMResult.updateDirty(): " + this.getClass().getSimpleName() + ": setting dirty to true: last = "+ lastValue + " / new = " + newValue);
 			this.setDirty();
 		}
 	}
 
 	/**
-	 * Updates the dirty states by comparing TXMResult @Parameter with previously
-	 * used parameters in the compute() method.
+	 * Updates the dirty states by comparing TXMResult @Parameter with previously used parameters in the compute() method.
 	 * 
-	 * To work correctly : - the equals method of the TXMResult parameters must be
-	 * correctly implemented. - the @Parameter member must be another variable (the
-	 * previous is stored in the lastParameters protected variable) (e.g editing a
-	 * List @Parameter is not enough for this test)
+	 * To work correctly :
+	 *  - the equals method of the TXMResult parameters must be correctly implemented.
+	 *  - the @Parameter member must be another variable (the previous is stored in the lastParameters protected variable) (e.g editing a List @Parameter is not enough for this test)
 	 * 
-	 * The method is final and don't need to be re-implemented. To ignore this
-	 * method, don't use the @Parameter annotations
+	 * The method is final and don't need to be re-implemented. To ignore this method, don't use the @Parameter annotations
 	 * 
 	 * Implement isDirty if you need more test
 	 * 
 	 * @return
-	 * @throws IllegalAccessException
-	 * @throws IllegalArgumentException
+	 * @throws IllegalAccessException 
+	 * @throws IllegalArgumentException 
 	 */
 	public final boolean isDirtyFromHistory() throws Exception {
 
 		List<Field> fields = this.getAllFields();
-
+		
 		for (Field f : fields) {
 			Parameter parameter = f.getAnnotation(Parameter.class);
-			if (parameter == null || parameter.type() != Parameter.COMPUTING
-			// FIXME: non electric mode tests
-			// || parameter.electric() == false
-			) {
+			if (parameter == null
+					|| parameter.type() != Parameter.COMPUTING
+					// FIXME: non electric mode tests
+					//|| parameter.electric() == false 
+					) {
 				continue;
 			}
 			String name;
-			if (!parameter.key().isEmpty()) {
+			if (!parameter.key().isEmpty())	{
 				name = parameter.key();
-			} else {
+			}
+			else {
 				name = f.getName();
 			}
 
@@ -779,8 +759,8 @@
 			Object previousValue = this.getLastParametersFromHistory().get(name);
 			Object newValue = f.get(this);
 
-			// // FIXME: debug
-			// Log.finest("TXMResult.isDirtyFromHistory(): checking parameter: " + name);
+			//			// FIXME: debug
+			//			Log.finest("TXMResult.isDirtyFromHistory(): checking parameter: " + name);
 
 			this.updateDirty(previousValue, newValue);
 			if (this.dirty) {
@@ -791,7 +771,8 @@
 		return this.dirty;
 	}
 
-	public HashMap<String, Object> getLastParametersFromHistory() {
+
+	public HashMap<String, Object> getLastParametersFromHistory()	{
 		return this.parametersHistory.get(this.parametersHistory.size() - 1);
 	}
 
@@ -805,19 +786,16 @@
 	}
 
 	/**
-	 * Marks the result as dirty so editors or others will know the TXMResult needs
-	 * to be recomputed. This method is also recursively called on all the children
-	 * branch to mark them as dirty.
+	 * Marks the result as dirty so editors or others will know the TXMResult needs to be recomputed.
+	 * This method is also recursively called on all the children branch to mark them as dirty.
 	 */
 	public void setDirty() {
 		this.setDirty(true);
 	}
 
 	/**
-	 * Sets the result dirty state so editors or others will know the TXMResult
-	 * needs to be recomputed or not. This method is also recursively called on all
-	 * the children branch sets the new dirty state.
-	 * 
+	 *  Sets the result dirty state so editors or others will know the TXMResult needs to be recomputed or not.
+	 *  This method is also recursively called on all the children branch sets the new dirty state.
 	 * @param dirty
 	 */
 	public void setDirty(boolean dirty) {
@@ -826,6 +804,7 @@
 			this.children.get(i).setDirty(dirty);
 		}
 	}
+	
 
 	/**
 	 * Gets the value of the specified key in parameters, local result node or
@@ -893,33 +872,31 @@
 		return TXMPreferences.getString(key, this, this.commandPreferencesNodePath);
 	}
 
+
 	/**
 	 * Checks if the specified parameter exists.
-	 * 
 	 * @param key
 	 * @return
 	 */
-	public boolean parameterExists(String key) {
+	public boolean parameterExists(String key)	{
 		return TXMPreferences.keyExists(this.parametersNodePath, key);
 	}
 
 	/**
-	 * Checks if a preference is empty (equals to "") in the command preference
-	 * node. An empty preference can be used to disable a functionality for a kind
-	 * of result (eg. A partition dimension bar chart does not have a legend so it
-	 * can be used to not offer the hide/show legend button in UI).
-	 * 
+	 * Checks if a preference is empty (equals to "") in the command preference node.
+	 * An empty preference can be used to disable a functionality for a kind of result
+	 * (eg. A partition dimension bar chart does not have a legend so it can be used to not offer the hide/show legend button in UI).
 	 * @param key
 	 * @return
 	 */
-	public boolean isEmptyPreference(String key) {
+	public boolean isEmptyPreference(String key)	{
 		return TXMPreferences.isEmpty(this.commandPreferencesNodePath, key);
 	}
 
+
+
 	/**
-	 * Stores the specified parameters pairs of key/value in a local node dedicated
-	 * to the specified result. The node qualifier is generated by the
-	 * <code>TXMResult.getUUID</code> method.
+	 * Stores the specified parameters pairs of key/value in a local node dedicated to the specified result. The node qualifier is generated by the <code>TXMResult.getUUID</code> method.
 	 * 
 	 * @param key
 	 * @return
@@ -928,29 +905,24 @@
 		this.saveParameter(key, StringUtils.join(values, UNDERSCORE));
 	}
 
+
 	/**
-	 * Stores the specified parameters pairs of key/value in a local node dedicated
-	 * to the specified result. The node qualifier is generated by the
-	 * <code>TXMResult.getUUID</code> method.
-	 * 
+	 * Stores the specified parameters pairs of key/value in a local node dedicated to the specified result. The node qualifier is generated by the <code>TXMResult.getUUID</code> method.
 	 * @param result
 	 * @param key
 	 * @param value
 	 */
-	public void saveParameter(String key, Object value) {
+	public void saveParameter(String key, Object value)	{
 		// FIXME: debug
-		// Log.info("TXMResult.saveParameter(): saving parameter " + key + " = " + value
-		// + " for " + this.getClass() + " (" + value.getClass() + ") to node.");
+		//Log.info("TXMResult.saveParameter(): saving parameter " + key + " = " + value + " for " + this.getClass() + " (" + value.getClass() + ") to node.");
 
 		TXMPreferences.putLocal(this, key, value);
 	}
 
+
 	/**
-	 * Stores the result parameter fields declared by their @Parameter annotation in
-	 * the persisted result node preferences. One have to implement saveParameters()
-	 * to save parameters that are not of primitive types (e.g. Property, List,
-	 * HashMap...)
-	 * 
+	 * Stores the result parameter fields declared by their @Parameter annotation in the persisted result node preferences.
+	 * One have to implement saveParameters() to save parameters that are not of primitive types (e.g. Property, List, HashMap...)
 	 * @return
 	 * @throws Exception
 	 */
@@ -962,19 +934,19 @@
 		this.saveParameter("class", this.getClass().getName()); //$NON-NLS-1$
 
 		this.saveParameter(TXMPreferences.RESULT_PARAMETERS_NODE_PATH, this.parametersNodePath);
-
-		// FIXME: old version that not work well if a bundle has no preference
-		// initializer
-		// this.saveParameter(TXMPreferences.BUNDLE_ID,
-		// this.commandPreferencesNodePath);
+		
+		// FIXME: old version that not work well if a bundle has no preference initializer
+		//this.saveParameter(TXMPreferences.BUNDLE_ID, this.commandPreferencesNodePath);
 		// FIXME: new version
 		this.saveParameter(TXMPreferences.BUNDLE_ID, FrameworkUtil.getBundle(getClass()).getSymbolicName());
-
-		if (this.parent != null) {
+		
+		
+		
+		if (this.parent != null)	{
 			this.saveParameter(TXMPreferences.PARENT_PARAMETERS_NODE_PATH, this.parent.getParametersNodePath());
 		}
 
-		if (this.hasBeenComputedOnce) {
+		if(this.hasBeenComputedOnce)	{
 			this.lazyName = this.getSimpleName();
 		}
 
@@ -990,16 +962,19 @@
 				continue; // no preference key defined
 			}
 
-			if (f.getType().isAssignableFrom(int.class) || f.getType().isAssignableFrom(Integer.class) || f.getType().isAssignableFrom(double.class) || f.getType().isAssignableFrom(Double.class)
-					|| f.getType().isAssignableFrom(float.class) || f.getType().isAssignableFrom(Float.class) || f.getType().isAssignableFrom(boolean.class)
-					|| f.getType().isAssignableFrom(Boolean.class) || f.getType().isAssignableFrom(String.class)
+			if (f.getType().isAssignableFrom(int.class) || f.getType().isAssignableFrom(Integer.class) ||
+					f.getType().isAssignableFrom(double.class) || f.getType().isAssignableFrom(Double.class) ||
+					f.getType().isAssignableFrom(float.class) || f.getType().isAssignableFrom(Float.class) ||
+					f.getType().isAssignableFrom(boolean.class) || f.getType().isAssignableFrom(Boolean.class) ||
+					f.getType().isAssignableFrom(String.class)
 
-			// FIXME: do not pass a Serializable for now
-			// || !f.getType().isAssignableFrom(Serializable.class)
-			// || !Serializable.class.isInstance(f)
+					// FIXME: do not pass a Serializable for now
+					//|| !f.getType().isAssignableFrom(Serializable.class)
+					//|| !Serializable.class.isInstance(f)
 
-			) {
+					) {
 
+
 				f.setAccessible(true); // set accessible to test the field values
 				try {
 					Object value = f.get(this);
